"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const select_1 = require("@material/select");
const aurelia_framework_1 = require("aurelia-framework");
const aurelia_templating_1 = require("aurelia-templating");
const aurelia_typed_observable_plugin_1 = require("aurelia-typed-observable-plugin");
aurelia_typed_observable_plugin_1.usePropertyTypeForBindable(true);
aurelia_typed_observable_plugin_1.usePropertyTypeForObservable(true);
let PiSelect = class PiSelect {
    get initialized() {
        return !!this._mdcComponent;
    }
    get value() {
        return this._mdcComponent.value;
    }
    set value(value) {
        this._mdcComponent.value = value;
    }
    get selectedIndex() {
        return this._mdcComponent.selectedIndex;
    }
    set selectedIndex(index) {
        this._mdcComponent.selectedIndex = index;
    }
    get valid() {
        return this._mdcComponent.valid;
    }
    set valid(isValid) {
        this._mdcComponent.valid = isValid;
    }
    set leadingIconAriaLabel(icon) {
        this._mdcComponent.leadingIconAriaLabel = icon;
    }
    set leadingIconContent(content) {
        this._mdcComponent.leadingIconContent = content;
    }
    set helperTextContent(content) {
        this._mdcComponent.helperTextContent = content;
    }
    layout() {
        this._mdcComponent.layout();
    }
    listen(eventName, handler, options) {
        this._mdcComponent.listen("MDCSelect:change", handler, options);
    }
    unlisten(eventName, handler, options) {
        this._mdcComponent.unlisten(eventName, handler, options);
    }
    attached() {
        this._mdcComponent = new select_1.MDCSelect(this._rootElement);
        this.onChange && this.listen("MDCSelect:change", event => {
            var _a, _b;
            (_b = (_a = this).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, {
                event,
                component: this
            });
        });
    }
    detached() {
        this._mdcComponent.destroy();
    }
};
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", String)
], PiSelect.prototype, "label", void 0);
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Boolean)
], PiSelect.prototype, "required", void 0);
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Boolean)
], PiSelect.prototype, "disabled", void 0);
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Boolean)
], PiSelect.prototype, "outlined", void 0);
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Function)
], PiSelect.prototype, "onChange", void 0);
PiSelect = __decorate([
    aurelia_templating_1.viewResources(aurelia_framework_1.PLATFORM.moduleName("./pi-select.css"))
], PiSelect);
exports.PiSelect = PiSelect;

//# sourceMappingURL=pi-select.js.map
